#include "mcu.h"
#include "led7seg.h"

static const unsigned short seg[16] =
{
				//		PGFE DCBA
	0xc0,		//	0	1100 0000
	0xf9,		//	1	1111 1001
	0xa4,		//	2	1010 0100
	0xb0,		//	3	1011 0000
	0x99,		//	4	1001 1001
	0x92,		//	5	1001 0010
	0x82,		//	6	1000 0010
	0xd8,		//	7	1101 1000
	0x80,		//	8	1000 0000
	0x90,		//	9	1001 0000
	0x88,		//	A	1000 1000
	0x83,		//	b	1000 0011
	0xa7,		//	c	1010 0111
	0xa1,		//	d	1010 0001
	0x86,		//	E	1000 0110
	0x8e,		//	F	1000 1110
};

void init_led7seg(void)
{
	FM3_GPIO->PFR4	&= ~(0x7C00);	//GPIOƂĎgp
	FM3_GPIO->PDOR4 |=	(0x7C00);	//HIo
	FM3_GPIO->DDR4	|=	(0x7C00);	//o͂Ƃ
	FM3_GPIO->PCR4	&= ~(0x7C00);	//vAbvȂ

	FM3_GPIO->PFR7	&= ~(0x07FF);	//GPIOƂĎgp
	FM3_GPIO->PDOR7 |=	(0x07FF);	//HIo
	FM3_GPIO->DDR7	|=	(0x07FF);	//o͂Ƃ
	FM3_GPIO->PCR7	&= ~(0x07FF);	//vAbvȂ

	return;
}

void led7seg_disp(uint16_t data)
{
	int h4bit, l4bit;

	h4bit = (data >> 4) & 0x0f;
	l4bit = (data >> 0) & 0x0f;

	FM3_GPIO->PDOR4 = (seg[l4bit] << 10);
	FM3_GPIO->PDOR7 = ((seg[l4bit] >> 5) | 0x7f8) & ((seg[h4bit] << 3) | 0x0007);

	return;
}
