/***************************************************************
	CPUŗL e평[`(FM3/MB9BF618Tp)
***************************************************************/

/* CPU/荞ݐ֐wb_ */
#include "cpu_init.h"


/* PLLNbNݒ背WX^` */
#define PLL_SCM_CTL   ((volatile unsigned char *)0x40010000)
#define PLL_SCM_STR   ((volatile unsigned char *)0x40010004)
#define PLL_BSC_PSR   ((volatile unsigned char *)0x40010010)
#define PLL_APBC0_PSR ((volatile unsigned char *)0x40010014)
#define PLL_APBC1_PSR ((volatile unsigned char *)0x40010018)
#define PLL_APBC2_PSR ((volatile unsigned char *)0x4001001C)
#define PLL_CSW_TMR   ((volatile unsigned char *)0x40010030)
#define PLL_PSW_TMR   ((volatile unsigned char *)0x40010034)
#define PLL_PLL_CTL1  ((volatile unsigned char *)0x40010038)
#define PLL_PLL_CTL2  ((volatile unsigned char *)0x4001003C)


/* EHb`hbO^C}WX^` */
#define WDT_CTL     ((volatile unsigned int *)0x40011008)
#define WDT_LCK     ((volatile unsigned int *)0x40011C00)


/* CPUŗL */
void CPU_Initialize(void)
{
	/* EHb`hbO^C}fBZ[u */
	*WDT_LCK = 0x1ACCE551;	/* bN1 */
	*WDT_LCK = 0xE5331AAE;	/* bN2 */
	*WDT_CTL = 0x00000000;	/* fBZ[u */


	/* PLLNbNݒ(CPURA144MHz) */
	/* CUNbNN */
	*PLL_CSW_TMR = 0x4D;	/* TuF164msCCF131ms҂ */
	*PLL_SCM_CTL = 0x02;	/* CNbNUJn */
	while((*PLL_SCM_STR & 0x02)==0){}	/* ҂ */
	/* PLLNbNU */
	*PLL_PSW_TMR  = 0x06;	/* 8ms҂ */
	*PLL_PLL_CTL1 = 0x01;	/* K=0(1-1),M=1(2-1) */
	*PLL_PLL_CTL2 = 35;		/* N=35(36-1) */
	*PLL_SCM_CTL = 0x12;	/* PLLUJn */
	while((*PLL_SCM_STR & 0x10)==0){}	/* ҂ */
	/* NbNݒ */
	*PLL_BSC_PSR   = 0x00;	/* x[XNbN1/1(144MHz) */
	*PLL_APBC0_PSR = 0x02;	/* APB0NbN1/4(36MHz) */
	*PLL_APBC1_PSR = 0x82;	/* APB1NbN1/4(36MHz) */
	*PLL_APBC2_PSR = 0x82;	/* APB2NbN1/4(36MHz) */
	/* NbN؂ւ */
	*PLL_SCM_CTL = 0x52;	/* PLLUNbNI */

}

